Unit sf23z_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF11_p;

procedure sf23z(ARGR :Extended; ARGI :Extended; var ANSR :Extended;
                var ANSI :Extended; var EPS :Extended; L :Integer;
                var IERR :Integer);

implementation

procedure sf23z(ARGR :Extended; ARGI :Extended; var ANSR :Extended;
                var ANSI :Extended; var EPS :Extended; L :Integer;
                var IERR :Integer);
var
LF1,LF2,LF3,J,IFOVFL,K,N :Integer;
DELTA,DE0,DE1,ZZ1,W1,W2,Y1,A,B,U,U1,U2,UU1,UU2,UUU1,UUU2,V1,V2,VV1,
   VV2,T1,T2,H,H1,H2,AL1,AL2,DN :Extended;
COEF :Array [0..6] of Extended;
Z :Array [0..1] of Extended;
const
F0 :Real = 840.0738529605262e0;
F1 :Real = 20.00123082189420e0;
G0 :Real = 1680.147705921052e0;
G1 :Real = 180.0147704705204e0;
SYS001 :Real = 3.1415926535897932384626433832795;
SYS003 :Real = 6.2831853071795864769252867665590;
SYS027 :Real = 0.91893853320467274178032973640561;
SYS025 :Real = 1.8378770664093454835606594728112;
SYS051 :Real = 1.1107652e-16;
SYS059 :Real = 1.7E38;
SYS053 :Real = 1.7e308;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28;
begin
{   DATA  FORTRAN  }
COEF[0] := 0.6410256410256410e-2;
COEF[1] := -0.1917526917526918e-2;
COEF[2] := 0.8417508417508418e-3;
COEF[3] := -0.5952380952380952e-3;
COEF[4] := 0.7936507936507937e-3;
COEF[5] := -0.2777777777777778e-2;
COEF[6] := 0.8333333333333333e-1;
IERR := 0;
Z[0] := ARGR;
Z[1] := ARGI;
if ( Z[0] = 0.e0 ) and ( Z[1] = 0.e0 ) 
 then goto _6;
if ( Z[0] > 0.e0 ) 
 then goto _1;
if ( Z[1] = 0.e0 ) and ( Abs(((Trunc(Z[0])))) = 
     Abs(Z[0]) ) 
 then goto _6;
_1:
if ( L = 0 ) 
 then goto _7;
if ( Z[0] <> 0.e0 ) 
 then goto _3;
if ( Z[1] < (-27.5e0) ) 
 then goto _2;
if ( Z[1] <= 27.5e0 ) 
 then goto _7;
_2:
W1 := 0.e0;
W2 := 0.e0;
goto _27;
_3:
if ( Z[1] <> 0.e0 ) 
 then goto _7;
if ( Z[0] <= 408.909e0 ) 
 then goto _7;
IERR := 65;
_4:
UTSF11(IERR,23);
goto _28;
_5:
IERR := 66;
goto _4;
_6:
IERR := 67;
goto _4;
_7:
DELTA := Abs(EPS);
DE0 := 5.e0;
DE1 := 0.e0;
LF1 := 0;
if ( Z[1] >= 0.e0 ) 
 then goto _8;
LF1 := 1;
Z[1] := -Z[1];
_8:
LF2 := 0;
if ( Z[0] >= 0.e0 ) 
 then goto _12;
LF2 := 1;
LF1 := LF1-1;
T1 := SYS025-SYS001*Z[1];
T2 := SYS001*(0.5e0-Z[0]);
U := -SYS003*Z[1];
if ( U >= (-0.1054e0) ) 
 then goto _10;
A := 0.e0;
if ( U <= (-39.15e0) ) 
 then goto _9;
A := Exp(U);
_9:
H1 := 1.e0-A;
goto _11;
_10:
U2 := U*U;
A := -U*(F1*U2+F0);
H1 := (A+A)/((U2+G1)*U2+G0+A);
A := 1.e0-H1;
_11:
B := Z[0]-Trunc(Z[0]-0.5e0);
H2 := A*Sin(SYS003*B);
B := Sin(SYS001*B);
H1 := H1+(B+B)*B*A;
H := Abs(H2)+H1-SYS003*A*DELTA;
if ( H <= 0.e0 ) 
 then goto _26;
DE0 := DE0+Abs(T1)+T2;
DE1 := SYS001+SYS003*A/H;
Z[0] := 1.e0-Z[0];
_12:
LF3 := 0;
Y1 := Z[0]-0.5e0;
W1 := 0.e0;
W2 := 0.e0;
K := Trunc( 0.e0 );
B := EMax1(0.1e0,EMin1(10.e0,14.142e0-Z[1]))-Z[0];
if ( B <= 0.e0 ) 
 then goto _19;
LF3 := 1;
ZZ1 := Z[0];
N := Trunc( B+1.e0 );
DN := N;
Z[0] := Z[0]+DN;
A := Z[0]*Z[0]+Z[1]*Z[1];
V1 := Z[0]/A;
V2 := -Z[1]/A;
U1 := 1.e0-V1;
U2 := -V2;
K := Trunc( 6.e0-Z[1]*0.6e0-ZZ1 );
if ( K <= 0 ) 
 then goto _14;
N := N-K;
UU1 := (ZZ1*Z[0]+Z[1]*Z[1])/A;
UU2 := DN*Z[1]/A;
VV1 := 0.e0;
VV2 := 0.e0;
for J:=1 to K do
 begin
  B := U1*(UU1+VV1)-U2*(UU2+VV2);
  U2 := U1*(UU2+VV2)+U2*(UU1+VV1);
  U1 := B;
  VV1 := VV1+V1;
_13:
  VV2 := VV2+V2;
 end;
_14:
if ( N <= 1 ) 
 then goto _16;
VV1 := V1;
VV2 := V2;
for J:=2 to N do
 begin
  VV1 := VV1+V1;
  VV2 := VV2+V2;
  B := U1*(1.e0-VV1)+U2*VV2;
  U2 := -U1*VV2+U2*(1.e0-VV1);
_15:
  U1 := B;
 end;
_16:
U := U1*U1+U2*U2;
if ( U = 0.e0 ) 
 then goto _26;
if ( L = 0 ) 
 then goto _17;
if ( K <= 0 ) 
 then goto _19;
_17:
AL1 := Ln(U)*0.5e0;
if ( L <> 0 ) 
 then goto _18;
W1 := AL1;
W2 := ArcTan2(U2,U1);
if ( W2 < 0.e0 ) 
 then W2 := W2+SYS003;
if ( K <= 0 ) 
 then goto _19;
_18:
A := ZZ1+Z[1]-DELTA;
if ( A <= 0.e0 ) 
 then goto _26;
DE0 := DE0-AL1;
DE1 := DE1+2.e0+1.e0/A;
_19:
A := Z[0]*Z[0]+Z[1]*Z[1];
AL1 := Ln(A)*0.5e0;
AL2 := ArcTan2(Z[1],Z[0]);
V1 := Y1*AL1-Z[1]*AL2;
V2 := Y1*AL2+Z[1]*AL1;
VV1 := 0.e0;
VV2 := 0.e0;
if ( A > SYS053 ) 
 then goto _21;
UU1 := Z[0]/A;
UU2 := -Z[1]/A;
UUU1 := UU1*UU1-UU2*UU2;
UUU2 := UU1*UU2*2.e0;
VV1 := COEF[0];
for J:=2 to 7 do
 begin
  B := VV1*UUU1-VV2*UUU2;
  VV2 := VV1*UUU2+VV2*UUU1;
_20:
  VV1 := B+COEF[J-1];
 end;
B := VV1*UU1-VV2*UU2;
VV2 := VV1*UU2+VV2*UU1;
VV1 := B;
_21:
W1 := (((VV1+SYS027)-W1)-Z[0])+V1;
W2 := ((VV2-W2)-Z[1])+V2;
DE0 := DE0+Abs(V1)+Abs(V2);
if ( K <= 0 ) 
 then DE1 := DE1+AL1;
if ( LF2 <> 0 ) 
 then goto _22;
if ( L = 0 ) 
 then goto _25;
A := Exp(W1);
W1 := A*Cos(W2);
W2 := A*Sin(W2);
if ( LF3 = 0 ) 
 then goto _25;
B := (W1*U1+W2*U2)/U;
W2 := (W2*U1-W1*U2)/U;
W1 := B;
goto _25;
_22:
H := H1*H1+H2*H2;
if ( H = 0.e0 ) 
 then goto _26;
if ( L = 0 ) 
 then goto _23;
if ( H > 1.e-2 ) 
 then goto _24;
_23:
A := Ln(H)*0.5e0;
if ( H <= 1.e-2 ) 
 then DE0 := DE0-A;
if ( L <> 0 ) 
 then goto _24;
W1 := (T1-A)-W1;
W2 := (T2-ArcTan2(H2,H1))-W2;
goto _25;
_24:
T1 := T1-W1;
T2 := T2-W2;
A := Exp(T1);
T1 := A*Cos(T2);
T2 := A*Sin(T2);
W1 := (T1*H1+T2*H2)/H;
W2 := (T2*H1-T1*H2)/H;
if ( LF3 = 0 ) 
 then goto _25;
B := W1*U1-W2*U2;
W2 := W1*U2+W2*U1;
W1 := B;
_25:
if ( LF1 <> 0 ) 
 then W2 := -W2;
DE1 := DE0*SYS051+3.e-17+DE1*DELTA;
goto _27;
_26:
W1 := SYS059;
W2 := SYS059;
DE1 := SYS059;
_27:
ANSR := W1;
ANSI := W2;
EPS := DE1;
exit;
_28:
goto _26;
end;

end.
