//Fortran: EQUIVALENCE ( ... )
Unit sf39e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF23Z_p, UTSF13_p;

function sf39e(X :Extended; A :Extended; var IERR :Integer): Extended;

implementation

function sf39e(X :Extended; A :Extended; var IERR :Integer): Extended;
var
I,IERR1 :Integer;
AX,Y,Z,RATIO,REDUC,CUT,P,PNLG,RAB,CNT,YCNT :Extended;
V :Array [0..5] of Extended;
V1 :Array [0..5] of Extended;
const
BIG :Real = 3.0e9;
SYS089 :Real = 1.0e-15;
SYS059 :Real = 1.7E38;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13;
begin
{ Result -    SF39E  FORTRANe }
CUT := SYS089;
P := A;
Result := 0.e0;
if ( X >= 0.e0 )
 then goto _1;
IERR := 65;
goto _12;
_1:
if ( P > 0.e0 ) 
 then goto _2;
IERR := 66;
goto _12;
_2:
IERR := 0;
if ( X <> 0.e0 ) 
 then goto _3;
Result := 0.e0;
goto _13;
_3:
SF23Z(P,0.e0,PNLG,RAB,CUT,0,IERR1);
CNT := P*Ln(X);
YCNT := X+PNLG;
AX := Exp(CNT-YCNT);
if ( (X <= 1.e0) ) or ( (X < P) ) 
 then goto _7;
Y := 1.e0-P;
Z := X+Y+1.e0;
CNT := 0.e0;
V[0] := 1.e0;
V[1] := X;
V[2] := X+1.e0;
V1[0] := V[2];  //  EQUIVALENCE
V[3] := Z*X;
V1[1] := V[3];  //  EQUIVALENCE
Result := V[2]/V[3];
_4:
CNT := CNT+1.e0;
Y := Y+1.e0;
Z := Z+2.e0;
YCNT := Y*CNT;
V[4] := V1[0]*Z-V[0]*YCNT;
V1[2] := V[4];  //  EQUIVALENCE
V[5] := V1[1]*Z-V[1]*YCNT;
V1[3] := V[5];  //  EQUIVALENCE
if ( V[5] = 0.e0 ) 
 then goto _9;
RATIO := V[4]/V[5];
REDUC := Abs(Result-RATIO);
if ( REDUC > SYS089 ) 
 then goto _5;
if ( REDUC <= RATIO*SYS089 ) 
 then goto _6;
_5:
Result := RATIO;
goto _9;
_6:
Result := 1.e0-Result*AX;
goto _13;
_7:
RATIO := P;
CNT := 1.e0;
Result := 1.e0;
_8:
RATIO := RATIO+1.e0;
CNT := CNT*X/RATIO;
Result := Result+CNT;
if ( CNT > SYS089 ) 
 then goto _8;
Result := Result*AX/P;
goto _13;
_9:
for I:=1 to 4 do
 begin
  V[I-1] := V1[I-1];
  if ( I=3 ) then V1[0] := V[2]; //  EQUIVALENCE
  if ( I=4 ) then V1[1] := V[3]; //  EQUIVALENCE
_10:
 end;
if ( Abs(V[4]) < BIG ) 
 then goto _4;
for I:=1 to 4 do
 begin
  V[I-1] := V[I-1]/BIG;
  if ( I=3 ) then V1[0] := V[2]; //  EQUIVALENCE
  if ( I=4 ) then V1[1] := V[3]; //  EQUIVALENCE
_11:
 end;
goto _4;
_12:
UTSF13(IERR,39);
Result := SYS059;
_13:
exit;
end;

end.
